#!/bin/sh
PATH=/bin:/sbin:/usr/bin:/usr/sbin
# Bram Shirani (bram@aversion.net)
# http://www.aversion.net/secheck (secheck-support@aversion.net)

# PLEASE SPECIFY WHERE YOU WANT SECHECK INSTALLED. DEFAULT IS /root - please don't add trailing /
home=/root

# This script will install secheck on your system. It will create the needed files needed to compare against.
# If you add any users, please be sure to re-run this script.

#############################################################
# Begin INSTALL
# This install scrpt will:
# 1. change all secheck files to the correct permissions
# 2. make a baseline of system vitals (/etc/passwd&shadow and find all suid/guid files)
# 3. copy baselines to a "hidden directory"
# 4. ensure correct permissions on baselines
# 5. copy secheck files to /usr/local/etc/secheck
# 
# PLEASE VIEW THE INSTALL AND README FILES BEFORE CONTUNING
#
#############################################################################################################

# This section establishes the basline vitals of your system. All future secheck's will compare your current files 
# to the ones that are created here. I will add support for updating these files soon, if you need to do it before 
# I get around to it, just undo what has been done here.

echo "Creating secheck root directory..."
mkdir $home/.secheck
echo "...done"
echo "Copying current system files to secheck root..."
cp /etc/passwd $home/.secheck/
cp /etc/shadow $home/.secheck/
cp /etc/group $home/.secheck/
cp /etc/xinetd.conf $home/.secheck/
echo "...done"
echo "Setting permissions on system files in root directory to u=r, go-rxw, and making them immutable..."
chmod -R go-xrw $home/.secheck
chmod -R u=r $home/.secheck/*
chattr -R +i $home/.secheck/*
echo "...done"
# Ok, we've got the baseline stuff aquired. Now let's actually install our scripts to the correct location.
echo "Making /usr/local/etc/secheck..."
mkdir /usr/local/etc/secheck
echo "...done"
echo "Copying secheck files to /usr/local/etc/secheck..."
cp ./secheck /usr/local/etc/secheck/
cp ./security.check /usr/local/etc/secheck/
echo "...done"
echo "Setting permissions on secheck files..."
chmod u=rwx /usr/local/etc/secheck/secheck
chmod go-xwr /usr/local/etc/secheck/secheck
chmod u=rxw /usr/local/etc/secheck/security.check
chmod go-xwr /usr/local/etc/secheck/security.check
echo "...done"
# Okie doke.. 

echo
echo
echo "Please be sure to define the variables at the top of /usr/local/etc/secheck/secheck and security.check."
echo
echo
echo "Done."
echo
